;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Boom Boom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA $C2,x
					BEQ MAIN_CODE
					JSR GOAL_MAIN
					RTS
MAIN_CODE			JSR SUB_GFX             ; graphics routine
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /

					JSL $01802A             ; update position based on speed values
					INC $1570,x
					LDA $1504,x
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$01
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2           CMP #$02
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$03
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			CMP #$04
					BNE NOT_MODE5
					JSR MODE5
					RTS
NOT_MODE5			JSR MODE6
					RTS

GOAL_MAIN			JSR SUB_GFXG
                    LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08
                    BNE RETURNG              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURNG              ; /    ... return
					JSR STAR_DUST
					JSL $01802A             ; update position based on speed values
					LDA $AA,x
					CMP #$80
					BCS RETURNG
                    JSL $01A7DC
                    BCC RETURNG
					LDA #$0B
                    STA $1DFB
                    LDA #$FF
                    STA $13C6
                    STA $1493
					STZ $14C8,x
RETURNG				RTS

STAR_DUST			LDA $14
					AND #$03
					BNE STARDUST_R
					JSL $01ACF9
					AND #$0F
					CLC
					LDY #$00
					ADC #$FC
					BPL STARDUST_2
					DEY
STARDUST_2			CLC
					ADC $E4,x
					STA $02
					TYA
					ADC $14E0,x
					PHA
					LDA $02
					CMP $1A
					PLA
					SBC $1B
					BNE STARDUST_R
					LDA $148E
					AND #$0F
					CLC
					ADC #$FE
					ADC $D8,x
					STA $00
					LDA $14D4,x
					ADC #$00
					STA $01
					JSL $0285BA
STARDUST_R			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $80,$A0,$80,$A0
                    dcb $82,$A2,$82,$A2
                    dcb $84,$A4,$8A,$AA
                    dcb $86,$A6,$88,$A8
                    dcb $88,$A8,$86,$A6
                    dcb $8A,$AA,$84,$A4
					dcb $AE,$8C,$AE,$8E
					dcb $AE,$8E,$AE,$8C
					dcb $C8,$E8,$CA,$EA
					dcb $CC,$EC,$CE,$EE

HORZ_DISP           dcb $F8,$F8,$08,$08
VERT_DISP           dcb $F0,$00,$F0,$00
PROPERTIES          dcb $00,$00,$40,$40

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                
					LDA $1602,x
					ASL A
					ASL A
					STA $03
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    
                    
                    LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX

					LDA PROPERTIES,x
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

SUB_GFXG			JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA #$E6
                    STA $0302,y             ; / 

                    LDA #$05
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED1			dcb $F0,$10
X_SPEED2			dcb $E0,$20

MODE1				JSR CHECK_MARIO
					STZ $1602,x
					LDA $15AC,x
					BNE MODE1_1
					LDA $1463
					BEQ MODE1_E
					LDA #$80
					STA $15AC,x
					LDA #$05
					STA $1DFB
					STZ $1411
MODE1_E				RTS
MODE1_1				CMP #$80
					BCC MODE1_2	
					RTS
MODE1_2				CMP #$78
					BCC MODE1_3
					LDA #$01
					STA $1602,x
					RTS
MODE1_3				LDA #$D8
					STA $AA,x
					LDA $1528,x
					CLC
					ADC #$01
					STA $1504,x
					RTS

MODE2				JSR CHECK_MARIO
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED1,x
					PLX
					STA $B6,x
					LDA $15AC,x
					BNE MODE2_1
					LDA #$40
					STA $15AC,x
					JSR SUB_GET_DIR
MODE2_1				LDA $1588,x
					AND #$03
					CMP #$01
					BNE MODE2_2
					STZ $157C,x
					RTS
MODE2_2				LDA $E4,x
					AND #$F0
					BNE MODE2_E
					LDA #$01
					STA $157C,x
MODE2_E				RTS

MODE3				JSR CHECK_MARIO
					LDA $1594,x
					BNE MODE3_6
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$08
					STA $1602,x
					LDA #$E0
					STA $AA,x
					LDA $14D4,x
					BNE MODE3_3
					INC $151C,x
					LDA $151C,x
					BNE MODE3_5
					LDA #$01
					STA $1594,x
					RTS
MODE3_5				AND #$20
					BNE MODE3_4
					LDA #$F8
					STA $AA,x
					BRA MODE3_3
MODE3_4				LDA #$08
					STA $AA,x
MODE3_3				LDA $157C,x
					PHX
					TAX
					LDA X_SPEED1,x
					PLX
					STA $B6,x
					LDA $15AC,x
					BNE MODE3_1
					LDA #$40
					STA $15AC,x
					JSR SUB_GET_DIR
MODE3_1				LDA $1588,x
					AND #$03
					CMP #$01
					BNE MODE3_2
					STZ $157C,x
					RTS
MODE3_2				LDA $E4,x
					AND #$F0
					BNE MODE3_E
					LDA #$01
					STA $157C,x
MODE3_E				RTS
MODE3_6				INC $1594,x
					LDA #$09
					STA $1602,x
					LDA $1594,x
					CMP #$20
					BCS MODE3_7
					STZ $AA,x
					STZ $B6,x
					RTS
MODE3_7				CMP #$20
					BNE MODE3_8
					JSR SPEED_DEC
					RTS
MODE3_8				CMP #$50
					BCS MODE3_9
					LDA #$24
					STA $AA,x
					RTS
MODE3_9				STZ $1594,x
					STZ $151C,x
					RTS

MODE4				JSR CHECK_MARIO
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					CLC
					ADC #$02
					STA $1602,x
					LDA $157C,x
					PHX
					TAX
					LDA X_SPEED2,x
					PLX
					STA $B6,x
					LDA $15AC,x
					BNE MODE4_1
					LDA #$80
					STA $15AC,x
					LDA #$A0
					STA $AA,x
					RTS
MODE4_1				LDA $1588,x
					AND #$03
					CMP #$01
					BNE MODE4_2
					STZ $157C,x
					RTS
MODE4_2				LDA $E4,x
					AND #$F0
					BNE MODE4_E
					LDA #$01
					STA $157C,x
MODE4_E				RTS

MODE5				LDA $15AC,x
					BNE MODE5_2
					STZ $1504,x
					LDA #$B0
					STA $15AC,x
					RTS
MODE5_2				LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$06
					STA $1602,x
					STZ $151C,x
					STZ $1594,x
					STZ $AA,x
					STZ $B6,x
					RTS

MODE6				LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$06
					STA $1602,x
					STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					BNE MODE6_E
					LDA #$1E
					STA $1DFB
					LDA #$39
					STA $1DFC
					JSR GOAL_GEN
					STZ $14C8,x
MODE6_E				RTS



SPEED_DEC			LDA $E4,x
					CMP $94
					BCC SPEED2
					LDA $E4,x
					SEC
					SBC $94
					LSR A
					LSR A
					STA $B6,x
					LSR A
					CLC
					ADC $B6,x
					STA $B6,x
					LDA #$FF
					SEC
					SBC $B6,x
					STA $B6,x
					RTS
SPEED2				LDA $94
					SEC
					SBC $E4,x
					LSR A
					LSR A
					STA $B6,x
					LSR A
					CLC
					ADC $B6,x
					STA $B6,x
					RTS

CHECK_MARIO			JSL $01A7DC             ; check for mario/sprite contact
                    BCC RETURN_24           ; (carry set = contact)
					LDA $1504,x
					BEQ ENE_WINS
                    LDA $7D                 ; \  if mario's y speed < 10 ...
                    CMP #$10                ;  }   ... sprite will hurt mario
                    BMI ENE_WINS           ; /    
                    
MARIO_WINS          JSL $01AA33             ; set mario speed
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					LDA #$40
					STA $15AC,x
					LDA #$04
					STA $1504,x
					INC $1528,x
					LDA $1528,x
					CMP #$03
					BNE RETURN_24
					LDA #$60
					STA $15AC,x
					LDA #$05
					STA $1504,x
RETURN_24           RTS                     ; return 


ENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN2             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN2             RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN67            RTS
GOAL_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$C0
					STA $00AA,y
					LDA #$00
					STA $00B6,y
					LDA #$01
					STA $00C2,y
                    RTS                          ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         STZ $157C,x
                    LDA $E4,x
                    SEC
                    SBC $94
                    STA $0F
                    LDA $14E0,x
                    SBC $95
                    BPL LABEL16
                    INC $157C,x
LABEL16             RTS
